﻿// script de Pierre Labbe _ octobre 2013
// le script cree des copies (objets dynamiques) avec un masque de fusion et les noms qui conviennent
//
#target photoshop 
var originalUnits = app.preferences.rulerUnits;
app.preferences.rulerUnits = Units.PIXELS;
var H_ou_V = "H_ou_V";
//alert(H_ou_V);
var nom_suite;
var source;

tab_taille = new Array("29", "50", "57", "58","72", "76", "100", "114", "144", "152", "512", "1024");
//tableau utilisé ligne 114 puis 155.
cTID = function(s) { return app.charIDToTypeID(s); };
sTID = function(s) { return app.stringIDToTypeID(s); };
////////////////////////////////////////////////////////////////////////
//////////////////boite de dialogue///////////////////////////////////////////////////
function boite_dialog() {
	this.windowRef = null;
}
//
/**
 Functional part of this snippet. 
 Create a window of type "palette" (a modeless dialog) and display it.
 @return True if the snippet ran as expected, false otherwise.
 @type Boolean
*/
boite_dialog.prototype.run = function(){
 //remplissage du panneau   
 titre_du_panneau = {fr: "Générer des images pour les icônes DPS", en: "Generate images for the DPS icons",};
    var titre_du_pan = localize(titre_du_panneau); //contenu du titre
 titre_principal = {fr: "Choisir le fichier à traiter pour générer les images.", en: "Choose a file to generate images.",};
   var titrePanneau = localize(titre_principal); //contenu du titre
titre_commentaire0 = {fr: "(utiliser un fichier de ratio 4:3)", en: "(use file with ratio 4:3)",};
   var commentaire0 =  localize(titre_commentaire0); //contenu du commentaire
   var dialogPanneau =  localize(titre_principal); //contenu de la question posée
text_commentaire2 = {fr: "Les fichiers ouverts vont être fermés.", en: "Open files will be closed.",};
   var commentaire2 =  localize(text_commentaire2); //contenu du commentaire
text_commentaire1 = {fr: "[Attention : ce script nécessite la version 14.1 ou +]", en: "[Warning: script works with the 14.1 version or +]",};
   var commentaire1 =  localize(text_commentaire1);//contenu de la suite du commentaire
//longueur_ commentaire"////////////////////////////////" //
text_bt1 = {fr: "Parcourir…", en: "Browse…",}
text_bt2 = {fr: "Annuler", en: "Cancel",}
   var btnumero_1 = localize(text_bt1); //contenu du bouton du numero_2
   var btnumero_2 = localize(text_bt2); //contenu du bouton numero_4
 
	// Create a window of type palette.
	var win = new Window("dialog", titre_du_pan,[100,110,520,280]);  // bounds = [left, top, right, bottom]
	this.windowRef = win;
	// Add a frame for the contents.
	win.btnPanel = win.add("panel", [25,13,400,150], dialogPanneau);  // cadre intérieur = [left, top, right, bottom]
	win.btnPanel.commentaire = win.add("StaticText", [55,32,380,50], commentaire0); // commentaire
	win.btnPanel.commentaire += win.add("StaticText", [35,55,380,65], commentaire1); //mettre en commentaire s'il n'y a qu'une ligne
	win.btnPanel.commentaire += win.add("StaticText", [35,75,380,65], commentaire2); //mettre en commentaire s'il n'y a qu'une ligne
	// Add the components, two buttons
	win.btnPanel.numero_1Btn = win.btnPanel.add("button", [130, 85, 210, 110], btnumero_1);
	win.btnPanel.numero_2Btn = win.btnPanel.add("button", [230, 85, 310, 110], btnumero_2);
	// Register event listeners that define the button behavior
	/*win.btnPanel.numero_1Btn.onClick = function() {
		//$.writeln("numero_1 pressed");
        alert(H_ou_V);
	win.close();
    bouton_ouvert();
	// 'bouton_ouvert()' = nom de la fonctionqui doit être lancée, si le bt 1 est cliqué.
	};*/
	win.btnPanel.numero_1Btn.onClick = function() {
		//$.writeln("numero_2 pressed");
    win.close();
    bouton_autre();
// 'bouton_autre()' = nom de la fonctionqui doit être lancée, si le bt 1 est cliqué.
	};
	win.btnPanel.numero_2Btn.onClick = function() {
       //par défaut, ce bouton est Annuler
		win.close();
	};
	// Display the window
	win.show();
	return true;
};
//
if(typeof(boite_dialog_unitTest) == "undefined") {
    new boite_dialog().run();
};
//
////////////////// fin _boite de dialogue///////////////////////////////////////////////////

function bouton_autre(){
            try {
                if (!documents.length == 0 ){TOUT_fermer();}
                titre_dialog = {fr:"Choisir le fichier à traiter", en:"Select the file to be processed",}
                file = File.openDialog (localize(titre_dialog) ,"", false);
                open(file);
                var source = app.activeDocument.path ;
                //alert (source);
                app.activeDocument.suspendHistory("Create_icons", 'main(source)');
                
                }
            catch (e){
                ANNULER = {fr:"Opération annulée", en:"Process canceled",};
                alert(localize(ANNULER));
                }
};
//
//////////////////////////////////////////////////////////////////////////
//
function main(source) 
{

//etape 1 enregistre une copie sur le bureau, elle est nommée ICON
Enregistrer();
///enregistrement du fichier sous le nom ICON sur le bureau
// avtive la génération des copies
    generer_images();
    app.refresh(); ///rafraichi l'écran
    //$.write("\nimages générées");
// ///condition sur largeur du doc pour lancer la conversion du fond
if (activeDocument.width >activeDocument.height) { 
    var format ="paysage";
    //le doc est horizontal
    L_ou_H="_L_"; 
    suite_fr_en = {fr:"deux aperçus verticaux." , en:"two thumbnails verticals.",}
    var Lg ="2048px";
    var Hg ="1536px";
    var Lp ="1024px";
    var Hp ="768px";
    definir_Fond(Lg, Hg, Lp, Hp);
    var suite = localize(suite_fr_en);
    var nom_suite ="_H_";
    //H < L    
    var H = 50;
    var L = 66.6;
    }
else { 
     var format ="portrait";
     //le doc est vertical
    L_ou_H="_H_";
    suite_fr_en = {fr:"deux aperçus horizontaux." , en:"two thumbnails horizontals.",}
    var Lg ="1536px";
    var Hg ="2048px";
    var Lp ="768px";
    var Hp ="1024px";
    definir_Fond(Lg, Hg, Lp, Hp);
    var suite = localize(suite_fr_en);
    var nom_suite ="_L_";
    //H  L 
    var H = 66.6;
    var L = 50;
    };
//
//etape 3 création d'une sélection carrée
selection_transformer(H, L)
//etape 4 désélectionner
var idsetd = charIDToTypeID( "setd" );
    var desc4947 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref689 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref689.putProperty( idChnl, idfsel );
    desc4947.putReference( idnull, ref689 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idNone = charIDToTypeID( "None" );
    desc4947.putEnumerated( idT, idOrdn, idNone );
executeAction( idsetd, desc4947, DialogModes.NO );
//
//etape 5 convertir en objet dynamique
var idnewPlacedLayer = stringIDToTypeID( "newPlacedLayer" );
executeAction( idnewPlacedLayer, undefined, DialogModes.NO );
//
//etape 6 duplique une première fois le calque
var taille1 = tab_taille[0]+"x"+tab_taille[0]+" icon"+tab_taille[0]+".png, "+
                   tab_taille[1]+"x"+tab_taille[1]+" icon"+tab_taille[1]+".png," +
                   tab_taille[2]+"x"+tab_taille[2]+" icon"+tab_taille[2]+".png";
dupliquer_calque(taille1);
//
//etape 7 recuperer la sélection pour faire un masque de fusion
var idsetd = charIDToTypeID( "setd" );
    var desc4948 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref690 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref690.putProperty( idChnl, idfsel );
    desc4948.putReference( idnull, ref690 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idPrvs = charIDToTypeID( "Prvs" );
    desc4948.putEnumerated( idT, idOrdn, idPrvs );
executeAction( idsetd, desc4948, DialogModes.NO );
//
//etape 8  créer un masque de fusion
// 
var idMk = charIDToTypeID( "Mk  " );
    var desc4958 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
    var idChnl = charIDToTypeID( "Chnl" );
    desc4958.putClass( idNw, idChnl );
    var idAt = charIDToTypeID( "At  " );
        var ref699 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idMsk = charIDToTypeID( "Msk " );
        ref699.putEnumerated( idChnl, idChnl, idMsk );
    desc4958.putReference( idAt, ref699 );
    var idUsng = charIDToTypeID( "Usng" );
    var idUsrM = charIDToTypeID( "UsrM" );
    var idRvlS = charIDToTypeID( "RvlS" );
    desc4958.putEnumerated( idUsng, idUsrM, idRvlS );
executeAction( idMk, desc4958, DialogModes.NO );
//
//etape 9 duplique plusieurs fois le calque de base avec un autre nom
var taille2 = tab_taille[3]+"x"+tab_taille[3]+" icon"+tab_taille[3]+".png, "+
                   tab_taille[4]+"x"+tab_taille[4]+" icon"+tab_taille[4]+".png," +
                   tab_taille[5]+"x"+tab_taille[5]+" icon"+tab_taille[5]+".png";
var taille3 = tab_taille[6]+"x"+tab_taille[6]+" icon"+tab_taille[6]+".png, "+
                   tab_taille[7]+"x"+tab_taille[7]+" icon"+tab_taille[7]+".png," +
                   tab_taille[8]+"x"+tab_taille[8]+" icon"+tab_taille[8]+".png";
var taille4 = tab_taille[9]+"x"+tab_taille[9]+" icon"+tab_taille[9]+".png, "+
                   tab_taille[10]+"x"+tab_taille[10]+" icon"+tab_taille[10]+".png" ;
var taille5 = tab_taille[11]+"x"+tab_taille[11]+" icon"+tab_taille[11]+".png, ";
dupliquer_calque(taille2);
dupliquer_calque(taille3);
dupliquer_calque(taille4);
dupliquer_calque(taille5);
//
//etape 10 enregistre le document ICON.psd
var idsave = charIDToTypeID( "save" );
var desc4977 = new ActionDescriptor();
var idIn = charIDToTypeID( "In  " );
desc4977.putPath( idIn, new File( "~/Desktop/ICONS.psd" ) );
var idDocI = charIDToTypeID( "DocI" );
desc4977.putInteger( idDocI, 5209 );
var idsaveStage = stringIDToTypeID( "saveStage" );
var idsaveStageType = stringIDToTypeID( "saveStageType" );
var idsaveSucceeded = stringIDToTypeID( "saveSucceeded" );
desc4977.putEnumerated( idsaveStage, idsaveStageType, idsaveSucceeded );
executeAction( idsave, desc4977, DialogModes.NO );
//
//sélection du premier calque
activeDocument.activeLayer = activeDocument.layers[0];
//$.write("\nfin traitement.\n");

//////ajouter les aperçus de l'autre dimension.
          txt_suite = {fr:"Génération des images.\n11 icônes et 2 aperçus ont été générés. "+
           "Ces fichiers sont dans le dossier \"ICONS-assets\" sur le bureau."+
           "\n\nIl manque "+suite+ "\nQue voulez faire? \n- [Oui] => créer à partir d'un fichier à importer"+
           "\n- [Non] => Terminer sans faire les aperçus"+
            "\n\n[ATTENTION : après avoir cliqué [Oui], il faudra juste valider l'import qui va être réalisé]." , en:"Generating images: "+
            "\n11 icons and 2 thumbnails have been created. All these files are in the \"ICONS-assets\""+
            " folder on the desktop.\n\nMissing "+suite+ ":\nWhat do you do?\n— [Yes] => create it from a imported file."+
            "\n— [No] => Continue without these thumbnails."+
            "\n\n[WARNING: If you choose [Yes], you just will have to validate the import.].",}
app.refresh(); ///rafraichi l'écran
if(confirm(localize(txt_suite))){
    // importer puis renomer le calque importé///////
    //$.write("dossier destination : "+source);
    importer(source);
    if (format =="paysage") { 
        //l'import est vertical
        var Lg ="1536px";
        var Hg ="2048px";
        var Lp ="768px";
        var Hp ="1024px";
        activeDocument.activeLayer.name = Lg+" x "+Hg+" icon"+nom_suite+"2048.png, " + Lp+" x "+Hp +" icon"+nom_suite+"1024.png";}
    else { 
        //l'import est horizontal
        var Lg ="2048px";
        var Hg ="1536px";
        var Lp ="1024px";
        var Hp ="768px";
        activeDocument.activeLayer.name = Lg+" x "+Hg+" icon"+nom_suite+"2048.png, " + Lp+" x "+Hp +" icon"+nom_suite+"1024.png";
        }; //fin else 
    MESSAGE_FIN2 = {fr:"Génération d'images complète :\n 2 aperçus ont été ajoutés."+
                "Les fichiers sont dans le dossier \"ICONS-assets\" sur le bureau.", en:"Images generation completed: "+
                "\n 2 thumbnails have been added in the \"ICONS-assets\" folder on the desktop.",}
     app.refresh(); ///rafraichi l'écran
     alert(localize(MESSAGE_FIN2));
     activeDocument.save();
     }
else {
        FERMER = {fr:"Traitement terminé. Voulez-vous fermer fichier?",en:"Process completed. Did you want to close file?",}
    if(confirm(localize(FERMER))) {
        app.refresh(); ///rafraichi l'écran
        activeDocument.save();
        activeDocument.close();
        }   
    }
//
//retour au unités initiales et à l'état d'historique
app.preferences.rulerUnits = originalUnits;
}; //
/////////////////////////////////////////// fin de la fonction main()///////////////////////////////
// =============================================Les fonctions =============================================================//
////////////////////////fonction enregistrer
 function Enregistrer() {
//Aplatir
var idFltI = charIDToTypeID( "FltI" );
executeAction( idFltI, undefined, DialogModes.NO );

    var desc1 = new ActionDescriptor();
    var desc2 = new ActionDescriptor();
    desc2.putBoolean(sTID("maximizeCompatibility"), true);
    desc1.putObject(cTID('As  '), cTID('Pht3'), desc2);
    desc1.putPath(cTID('In  '), new File("~/Desktop/ICONS.psd"));
    desc1.putInteger(cTID('DocI'), 4890);
    desc1.putBoolean(cTID('LwCs'), true);
    desc1.putBoolean(cTID('EmbP'), false);
    executeAction(sTID('save'), desc1, DialogModes.NO);
  };
////////////////////////////////////////////////////
//
//fonction créer la copie de calque à partir de la sélection
  function creer_calque(taille) {
    var desc1 = new ActionDescriptor();
    var desc2 = new ActionDescriptor();
    desc2.putString(cTID('Nm  '), taille);
    desc1.putObject(cTID('Nw  '), cTID('Lyr '), desc2);
    desc1.putEnumerated(cTID('Usng'), cTID('ArSl'), cTID('Slct'));
    desc1.putBoolean(cTID('Cpy '), true);
    executeAction(sTID('make'), desc1, DialogModes.NO);
  };

//
////////////dupliquer calques
function dupliquer_calque(taille){
var idMk = charIDToTypeID( "Mk  " );
    var desc4880 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
    var desc4881 = new ActionDescriptor();
    var idNm = charIDToTypeID( "Nm  " );
    desc4881.putString( idNm, taille );
    var idLyr = charIDToTypeID( "Lyr " );
    desc4880.putObject( idNw, idLyr, desc4881 );
    var idUsng = charIDToTypeID( "Usng" );
    var idArSl = charIDToTypeID( "ArSl" );
    var idSlct = charIDToTypeID( "Slct" );
    desc4880.putEnumerated( idUsng, idArSl, idSlct );
    var idCpy = charIDToTypeID( "Cpy " );
    desc4880.putBoolean( idCpy, true );
executeAction( idMk, desc4880, DialogModes.NO );
};

 //////////////////////////////////////////////////
   // fonction convertir le fond en calques
function definir_Fond(Lg, Hg, Lp, Hp) {
      ///si largeur du doc = 2048 , c'est le  grand = 2048 => echelleGrand "" , et echellePetit  "200%",
      ///si largeur du doc = 1024 , c'est le  petit = 1024 => echelleGrand "200%" , et echellePetit  "",
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putProperty(cTID('Lyr '), cTID('Bckg'));
    desc1.putReference(cTID('null'), ref1);
    var desc2 = new ActionDescriptor();
    desc2.putString(cTID('Nm  '), Lg+" x "+Hg+" icon"+L_ou_H+"2048.png, " + Lp+" x "+Hp +" icon"+L_ou_H+"1024.png");
    desc2.putUnitDouble(cTID('Opct'), cTID('#Prc'), 100);
    desc2.putEnumerated(cTID('Md  '), cTID('BlnM'), cTID('Nrml'));
    desc1.putObject(cTID('T   '), cTID('Lyr '), desc2);
    executeAction(sTID('set'), desc1, DialogModes.NO);
  };
////
//////////////////////////////////////////////////

//fonction dui crerr la sélection à déformer
function selection_transformer(Hauteur, Largeur) {   
    message_selection= {fr:"Contenu de l'icône défini par une sélection :\nAgrandissez (avec Maj. enfoncée) la sélection qui va apparaître"+
    ", positionnez-la correctement sur l'image, puis validez la transformation.\nElle définira le contenu "+
    "des icônes.", en:"Creating a square selection to define the icon: \nExpand (with Shift) the selection that will appear" +
     " and  position it correctly on the image, then validate processing. \nIt will define the content of the icons.",};
    alert (localize (message_selection));
 //tout selectionner
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putProperty(cTID('Chnl'), sTID("selection"));
    desc1.putReference(cTID('null'), ref1);
    desc1.putEnumerated(cTID('T   '), cTID('Ordn'), cTID('Al  '));
    executeAction(sTID('set'), desc1, DialogModes.NO);
    //transfo
    var desc2 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putProperty(cTID('Chnl'), sTID("selection"));
    desc2.putReference(cTID('null'), ref1);
    desc2.putEnumerated(cTID('FTcs'), cTID('QCSt'), sTID("QCSAverage"));
    var desc3 = new ActionDescriptor();
    desc3.putUnitDouble(cTID('Hrzn'), cTID('#Pxl'), 0);
    desc3.putUnitDouble(cTID('Vrtc'), cTID('#Pxl'), 0);
    desc2.putObject(cTID('Ofst'), cTID('Ofst'), desc3);
    desc2.putUnitDouble(cTID('Wdth'), cTID('#Prc'), Hauteur);
    desc2.putUnitDouble(cTID('Hght'), cTID('#Prc'), Largeur);
    desc2.putEnumerated(cTID('Intr'), cTID('Intp'), cTID('Bcbc'));
    executeAction(sTID('transform'), desc2, DialogModes.ALL);
  };
//
//////////////////////////////////////////////////////////
////////generer les images menu Fichier<generer<images////////////
function generer_images(){
    //fonction qui active (avec true) ou désactive (avec false) la génération des images
var pluginName = "assets";
var gScriptResult;
try { 
	var generatorDesc = new ActionDescriptor();
	generatorDesc.putString (app.stringIDToTypeID ("name"), pluginName);
	var returnDesc = executeAction( app.stringIDToTypeID ("generateAssets"), generatorDesc, DialogModes.NO );
     }
// In case anything goes wrong.
catch (e) {
    //gScriptResult = 'cancel';
    message3 = {fr:"Lancez la commande 'Fichier d'images' du menu Fichier>Générer", en:"You must run 'File>Génerate>File'",};
    alert(localize(message3));
    }
};
//
///////fonction importer image
function importer(source){
    var desc1 = new ActionDescriptor();
    desc1.putPath(cTID('null'), new File(source));
    //desc1.putPath(cTID('null'), new File("~/Desktop/File or Folder not found"));
    desc1.putEnumerated(cTID('FTcs'), cTID('QCSt'), sTID("QCSAverage"));
    var desc2 = new ActionDescriptor();
    desc2.putUnitDouble(cTID('Hrzn'), cTID('#Pxl'), 0);
    desc2.putUnitDouble(cTID('Vrtc'), cTID('#Pxl'), 0);
    desc1.putObject(cTID('Ofst'), cTID('Ofst'), desc2);
    executeAction(sTID('placeEvent'), desc1, DialogModes.ALL);
    // transformer
    desc1.putEnumerated(cTID('FTcs'), cTID('QCSt'), sTID("QCSAverage"));
    var desc4 = new ActionDescriptor();
    var desc5 = new ActionDescriptor();
    desc4.putUnitDouble(cTID('Hrzn'), cTID('#Pxl'), 0);
    desc4.putUnitDouble(cTID('Vrtc'), cTID('#Pxl'), 0);
    desc5.putObject(cTID('Ofst'), cTID('Ofst'), desc4);
    desc5.putUnitDouble(cTID('Wdth'), cTID('#Prc'), 133.33);
    desc5.putUnitDouble(cTID('Hght'), cTID('#Prc'), 133.33);
    desc5.putBoolean(cTID('Lnkd'), true);
    executeAction(sTID('transform'), desc5, DialogModes.NO);
    //tout voir
    var desc3 = new ActionDescriptor();
    executeAction(sTID('revealAll'), desc3, DialogModes.NO);
};
//
function TOUT_fermer(){
    try {
cTID = function(s) { return app.charIDToTypeID(s); };
sTID = function(s) { return app.stringIDToTypeID(s); };
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putEnumerated(cTID('Mn  '), cTID('MnIt'), cTID('ClsA'));
    desc1.putReference(cTID('null'), ref1);
    executeAction(sTID('select'), desc1, DialogModes.NO);
    }
    catch (e) {
//$.write("\nAnnulation début");
                    ANNULER1 = {fr:"Opération annulée", en:"Process canceled",};
                    alert(localize(ANNULER1));
                }
  };
//